/***************************************************************************
 *            quickSort_4.c
 *
 *  Wed Oct 17 02:00:15 2007
 *  Copyright  2007  pchero
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
 
int stack[100] = {0};	// 스택 배열
 
int top = -1;	// 스택에서 현재 위치를 나타내는 변수

int push(int i);	// push 함수
int pop();	// pop 함수
void swap(int *a, int *b);	// 스왑 함수
void quick_array(int low, int high, int* data);	// 퀵 정렬 함수

int main()
{
	int i;
	int data_array[10] = {4, 8, 3, 9, 7, 10, 5, 2, 1, 6};	// 정렬하고자 하는 데이터

	quick_array(0, 9, data_array);	// 퀵정렬 함수 호출

	for(i = 0; i < 10; i++)	// 데이터에 저장된 자료 출력
		printf("%d ", data_array[i]);
	
	return 0;
}


void quick_array(int low, int high, int data[])	// 퀵 정렬 함수
{
	int i, j;
	int key;

	push(low);
	push(high);

	while(top >= 0) {	// 스택에 수록된 값이 남아 있는한 반복
		high = pop();
		low = pop();

		if(high - low > 0) {
			key = data[low];	// 비교 기준값
			i = low;		// 왼쪽 시작 위치 - 1
			j = high + 1;	// 오른쪽 시작 위치 + 1;
	
			while(1) {
				while(data[++i] < key);	// 왼쪽에서 key보다 큰 값을 찾는다.
				while(data[--j] > key);		// 오른쪽에서 key보다 작은 값을 찾는다.
				
				if(i >= j)
					break;	// i, j 가 서로 교차했으면 while루프 끝
			
				swap(&data[i], &data[j]);
			}
			data[low] = data[j];
			data[j] = key;
	
			push(low);
			push(j - 1);
			push(j + 1);
			push(high);
		}
	}
}

void swap(int *a, int *b)	// 스왑 함수
{
	int temp;
	temp = *a;
	*a = *b;
	*b = temp;
}

int push(int i)
{
	top;

	if(top > 100) {
		printf("\n Stack Overflow...\n");
		return -1;
	}
	stack[++top] = i;
	printf("push : %d \n", stack[top]);
	return 0;
}

int pop()	// pop 함수
{
	if(top < 0) {
		printf("\nbottom\n");
		return -1;
	}

	printf("pop : %d\n", stack[top]);
	return stack[top--];
}
